
!UiModelIndex methodsFor: 'dragging' stamp: 'mt 10/19/2010 15:23:07.236'!
dragLabel

	^ self text asString! !

!UiComboBox class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:29:17.438'!
widgetCategory
	
	^ 'Input Widgets'! !

!UiContainer class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:29:36.611'!
widgetCategory
	
	^ 'Containers'! !

!UiContainer methodsFor: 'dropping/grabbing' stamp: 'mt 10/19/2010 15:40:56.326'!
acceptDroppingMorph: aMorph event: evt

	(aMorph isKindOf: TransferMorph)
		ifTrue: [ | widgetClass widget |
			widgetClass := aMorph passenger model widgetAt: aMorph passenger.
			widgetClass ifNil: [^ self].
			widget := widgetClass new.
			widget position: evt position.
			self addMorphBack: widget.
			
			(widget isKindOf: UiContainer)
				ifTrue: [widget editMode: self editMode].
			
		^ self].

	^ super acceptDroppingMorph: aMorph event: evt.! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:29:53.936'!
widgetCategory
	
	^ 'Display Widgets'! !

!UiListWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:33:00.509'!
widgetCategory
	
	^ 'Item Widgets (Item-Based)'! !

!UiStackedWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:05:23.132'!
widgetClassName

	^ 'Stacked Widget'! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/19/2010 13:31:11.159'!
widgetCategory
	
	^ 'Classic Morphs'! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/19/2010 13:38:38.799'!
widgetClassName

	^ self name! !

!UiAbstractItemView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:33:18.144'!
widgetCategory
	
	^ 'Item Views (Model-Based)'! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:12:01.1'!
addHorizontalHeader

	self addMorph: hHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:11:36.704'!
addVerticalHeader

	self addMorph: vHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'headers - testing' stamp: 'mt 10/14/2010 13:04:29.063'!
hasHorizontalHeader

	^ hHeaderScroller owner notNil! !

!UiAbstractItemView methodsFor: 'headers - testing' stamp: 'mt 10/14/2010 13:03:13.199'!
hasVerticalHeader

	^ vHeaderScroller owner notNil! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:11:54.15'!
removeHorizontalHeader

	self removeMorph: hHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:11:43.32'!
removeVerticalHeader

	self removeMorph: vHeaderScroller.
	self updateLayout.! !

!UiTreeView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:31:46.249'!
isWidgetClass

	^ true! !

!UiTreeView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:04:01.037'!
widgetClassIcon

	^ UiFugueIcons uiScrollPaneTreeIcon! !

!UiTreeView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:32:03.461'!
widgetClassName

	^ 'Tree View'! !

!UiTreeView methodsFor: 'expand/collapse' stamp: 'mt 10/19/2010 14:40:36.647'!
toggleTopLevelRow: aRowIndex

	self toggleIndex: ((UiSimpleModelIndex row: aRowIndex column: 1) model: self model).! !

!UiDesigner methodsFor: 'initialization' stamp: 'mt 10/19/2010 14:36:57.283'!
createMainContainer

	| main widgetListContainer filterRow filterEdit |	
	main := Morph new
		color: (Color gray: 0.8);
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	
	widgetListContainer := Morph new
		color: Color transparent;
		changeTableLayout;
		listDirection: #topToBottom;
		hResizing: #shrinkWrap;
		vResizing: #spaceFill.
		
	filterRow := Morph new
		color: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		layoutInset: 1;
		cellInset: 4.
	
	filterEdit := UiLineEdit new hResizing: #spaceFill.

	self connect: filterEdit signal: #textEdited: toSelector: #changeWidgetNameFilter:.

	filterRow
		addMorphBack: (UiLabel new form: UiFugueIcons magnifierIcon; setBalloonText: 'Search');
		addMorphBack: filterEdit.
	
	widgetListContainer
		addMorphBack: widgetList;
		addMorphBack: filterRow.
	
	main
		addMorphBack: widgetListContainer;
		addMorphBack: container;
		addMorphBack: (propertyTable withScrollBar vResizing: #spaceFill).
	
	^ main! !

!UiDesigner methodsFor: 'initialization' stamp: 'mt 10/19/2010 15:44:39.397'!
initialize

	super initialize.
	self
		color: (Color gray: 0.4);
		changeTableLayout;
		listDirection: #topToBottom;
		extent: 800@600.
		
	widgetList := UiTreeView new
		removeHorizontalHeader;
		model: UiWidgetListModel new;
		vResizing: #spaceFill;
		width: 180.
	1 to: (widgetList model rowCountFor: nil) - 1 do: [:i |
		widgetList toggleTopLevelRow: i].
	
	"BAD: Viewport should not be accessed from the outside."
	widgetList viewport dragEnabled: true.
		
	propertyTable := UiPropertyTable new.
	
	"New empty container."
	container := UiContainer new.
	self initializeContainer.
	
	self
		addMorphBack: self createToolbar;
		addMorphBack: self createMainContainer.! !

!UiButton class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:28:38.684'!
widgetCategory
	
	^ 'Buttons'! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:06:19.428'!
widgetCategory

	^ 'Input Widgets'! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/19/2010 15:40:41.889'!
startDrag: evt 
	
	evt hand hasSubmorphs ifTrue: [^ self].
	self dragEnabled ifFalse: [^ self].
	
	[ | index ddm |
	
	(index := self modelIndexFor: (self cellIndexFromPoint: evt position))
		ifNil: [^ self].

	evt hand grabMorph: (TransferMorph withPassenger: index)]
		ensure: [Cursor normal show.
			evt hand releaseMouseFocus: self]! !

!UiListView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:33:10.372'!
widgetCategory
	
	^ 'Item Views (Model-Based)'! !

!UiListView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:32:43.734'!
widgetClassName

	^ 'List View (old)'! !

!UiListIconView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:31:39.613'!
isWidgetClass

	^ true! !

!UiListIconView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:03:20.427'!
widgetClassIcon

	^ UiFugueIcons uiListBoxIcon! !

!UiListIconView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:06:46.933'!
widgetClassName

	^ 'List View'! !

UiItemModel subclass: #UiWidgetListModel
	instanceVariableNames: 'widgets nameFilter typeFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Designer'!

!UiWidgetListModel methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:28:18.977'!
categoryAt: aModelIndex

	aModelIndex parent ifNotNil: [^ self categoryAt: aModelIndex parent].
	
	^ self sortedCategories at: aModelIndex row! !

!UiWidgetListModel methodsFor: 'counts' stamp: 'mt 10/19/2010 13:42:17.033'!
columnCountFor: aParentModelIndex

	^ 1! !

!UiWidgetListModel methodsFor: 'model data' stamp: 'mt 10/19/2010 14:21:38.023'!
iconFor: aModelIndex

	(aModelIndex row = 0 or: [aModelIndex column = 0])
		ifTrue: [^ nil].
	
	self isFiltered ifTrue: [^ (widgets at: aModelIndex row) widgetClassIcon].

	aModelIndex parent ifNotNil: [:parent |
		^ (self widgetAt: aModelIndex) widgetClassIcon].
	
	^ nil! !

!UiWidgetListModel methodsFor: 'index generation' stamp: 'mt 10/19/2010 13:58:35.423'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	^ (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self;
		parent: aParentModelIndex! !

!UiWidgetListModel methodsFor: 'initialization' stamp: 'mt 10/19/2010 14:09:13.699'!
initialize

	super initialize.
	self updateWidgets.
	
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #class
		using: #processNotification:.! !

!UiWidgetListModel methodsFor: 'testing' stamp: 'mt 10/19/2010 14:18:39.402'!
isFiltered

	^ self nameFilter notNil and: [self nameFilter notEmpty]! !

!UiWidgetListModel methodsFor: 'accessing' stamp: 'mt 7/1/2010 17:38:43.629'!
nameFilter

	^ nameFilter ifNil: [nameFilter := '']! !

!UiWidgetListModel methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:20:28.689'!
nameFilter: aString

	nameFilter := aString.
	self updateWidgets.! !

!UiWidgetListModel methodsFor: 'updating' stamp: 'mt 10/19/2010 14:09:28.021'!
processNotification: event

	self updateWidgets.! !

!UiWidgetListModel methodsFor: 'counts' stamp: 'mt 10/19/2010 14:31:38.223'!
rowCountFor: aParentModelIndex

	self isFiltered ifTrue: [^ aParentModelIndex isNil
		ifTrue: [widgets size]
		ifFalse: [0]].
	
	aParentModelIndex ifNil: [^ widgets keys size].
	
	aParentModelIndex parent ifNotNil: [^ 0].
	
	^ (widgets at: (self sortedCategories at: aParentModelIndex row)) size! !

!UiWidgetListModel methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:30:09.005'!
sortedCategories

	^ (widgets keys copyWithout: Morph widgetCategory) sort, {Morph widgetCategory}! !

!UiWidgetListModel methodsFor: 'model data' stamp: 'mt 10/19/2010 14:44:33.217'!
textFor: aModelIndex

	aModelIndex row = 0 ifTrue: [^ 'Widgets'].
	aModelIndex column = 0 ifTrue: [^ ''].

	self isFiltered ifTrue: [^ (widgets at: aModelIndex row) widgetClassName].
	
	aModelIndex parent ifNotNil: [:parent |
		^ (self widgetAt: aModelIndex) widgetClassName].
	
	^ ('<b>', (self categoryAt: aModelIndex), '</b>') asHtmlText! !

!UiWidgetListModel methodsFor: 'updating' stamp: 'mt 10/19/2010 14:18:58.653'!
updateWidgets

	self isFiltered ifTrue: [^ self updateWidgetsWithFilter].

	widgets := Dictionary new.
	Morph allSubclassesDo: [:c |
		(widgets includesKey: c widgetCategory)
			ifFalse: [(widgets at: c widgetCategory put: SortedCollection new)
				sortBlock: [:i1 :i2 | i1 widgetClassName < i2 widgetClassName]].
		
		(c isWidgetClass or: [c widgetCategory = Morph widgetCategory])
			ifTrue: [(widgets at: c widgetCategory) add: c]].
	
	self modelReset.! !

!UiWidgetListModel methodsFor: 'updating' stamp: 'mt 10/19/2010 14:35:40.366'!
updateWidgetsWithFilter

	widgets := SortedCollection new
		sortBlock: [:i1 :i2 | i1 widgetClassName < i2 widgetClassName].
		
	Morph allSubclassesDo: [:c |
		(c widgetClassName asLowercase includesSubString: self nameFilter asString asLowercase)
			ifTrue: [widgets add: c]].

	self modelReset.! !

!UiWidgetListModel methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:28:30.434'!
widgetAt: aModelIndex

	aModelIndex parent ifNil: [^ nil].
	
	^ (widgets at: (self sortedCategories at: aModelIndex parent row)) at: aModelIndex row! !

!UiTableView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:31:43.968'!
isWidgetClass

	^ true! !

!UiTableView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:07:06.235'!
widgetClassIcon

	^ UiFugueIcons uiScrollPaneTableIcon! !

!UiTableView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:32:09.963'!
widgetClassName

	^ 'Table View'! !
