
!Morph class methodsFor: '*widgets-designer' stamp: 'mt 6/30/2010 21:08:33.026'!
widgetClassName

	^ ''! !

!UiListView class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:09:31.324'!
widgetClassName

	^ 'List View'! !

UiListView subclass: #UiWidgetList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Designer'!

!UiWidgetList classSide methodsFor: 'testing' stamp: 'mt 6/28/2010 21:33:22.954'!
isWidgetClass

	^ false! !

!UiWidgetList classSide methodsFor: 'instance creation' stamp: 'mt 10/19/2010 11:48:12.133'!
new

	^ (super new
		on: UiWidgetListModel new
		list: #widgetList
		selected: nil
		changeSelected: nil
		menu: nil
		keystroke: #arrowKey:from:)
		dragEnabled: true;
		iconSizeSelector: #iconSize;
		getIconsSelector: #iconList.! !

!UiWidgetList methodsFor: 'drag and drop' stamp: 'mt 6/28/2010 16:40:02.884'!
startDrag: evt 
	
	evt hand hasSubmorphs
		ifTrue: [^ self].
	[ | draggedItem draggedItemMorph passenger ddm |
	(self dragEnabled)
		ifFalse: [^ self].
	(draggedItem := self getListItem: (self rowAtLocation: evt position))
		ifNil: [^ self].
	draggedItemMorph := StringMorph contents: draggedItem asStringOrText.
	passenger := self model dragPassengerFor: draggedItemMorph inMorph: self.
	passenger
		ifNil: [^ self].
	ddm := TransferMorph withPassenger: passenger from: self.
	ddm
		dragTransferType: (self model dragTransferTypeForMorph: self).
"	Preferences dragNDropWithAnimation
		ifTrue: [self model dragAnimationFor: draggedItemMorph transferMorph: ddm]."
	evt hand grabMorph: ddm]
		ensure: [Cursor normal show.
			evt hand releaseMouseFocus: self]! !

!UiDesigner methodsFor: 'updating' stamp: 'mt 7/1/2010 17:41:25.518'!
changeWidgetFilter: aNumber

	widgetList model typeFilter: aNumber.! !

!UiDesigner methodsFor: 'initialization' stamp: 'mt 7/4/2010 08:54:09.147'!
createMainContainer

	| main widgetListContainer combo filterRow filterEdit |	
	main := Morph new
		color: (Color gray: 0.8);
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	
	widgetListContainer := Morph new
		color: Color transparent;
		changeTableLayout;
		listDirection: #topToBottom;
		hResizing: #shrinkWrap;
		vResizing: #spaceFill.
		
	filterRow := Morph new
		color: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		layoutInset: 1;
		cellInset: 4.
		
	combo := UiComboBox new hResizing: #spaceFill.
	combo
		addText: 'Widgets Only'; "Model expects index 1"
		addText: 'All Morphs (experimental)'. "Model expects index 2"
		
	self connect: combo signal: #currentIndexChanged:text: toSelector: #changeWidgetFilter:.
	
	filterEdit := UiLineEdit new hResizing: #spaceFill.

	self connect: filterEdit signal: #textEdited: toSelector: #changeWidgetNameFilter:.

	filterRow
		addMorphBack: (UiLabel new form: UiFugueIcons magnifierIcon; setBalloonText: 'Search');
		addMorphBack: filterEdit.
	
	widgetListContainer
		addMorphBack: combo;
		addMorphBack: widgetList;
		addMorphBack: filterRow.
	
	main
		addMorphBack: widgetListContainer;
		addMorphBack: container;
		addMorphBack: (propertyTable withScrollBar vResizing: #spaceFill).
	
	^ main! !

!UiDesigner methodsFor: 'initialization' stamp: 'mt 6/30/2010 12:16:40.014'!
initialize

	super initialize.
	self
		color: (Color gray: 0.4);
		changeTableLayout;
		listDirection: #topToBottom;
		extent: 800@600.
		
	widgetList := UiWidgetList new
		vResizing: #spaceFill.
	propertyTable := UiPropertyTable new.
	
	"New empty container."
	container := UiContainer new.
	self initializeContainer.
	
	self
		addMorphBack: self createToolbar;
		addMorphBack: self createMainContainer.! !

Object subclass: #UiWidgetListModel
	instanceVariableNames: 'nameFilter typeFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Designer'!

!UiWidgetListModel methodsFor: 'as yet unclassified' stamp: 'mt 10/19/2010 11:48:45.567'!
iconList

	^ self widgetList collect: [:className |
		(Smalltalk at: className asSymbol) widgetClassIcon]! !

!UiWidgetListModel methodsFor: 'as yet unclassified' stamp: 'mt 10/19/2010 11:44:50.385'!
iconSize

	^ 16@16! !

!UiWidgetListModel methodsFor: 'as yet unclassified' stamp: 'mt 7/1/2010 17:38:43.629'!
nameFilter

	^ nameFilter ifNil: [nameFilter := '']! !

!UiWidgetListModel methodsFor: 'as yet unclassified' stamp: 'mt 7/1/2010 17:41:56.732'!
nameFilter: aString

	nameFilter := aString.
	self changed: #widgetList.! !

!UiWidgetListModel methodsFor: 'as yet unclassified' stamp: 'mt 7/1/2010 17:37:48.278'!
typeFilter
	
	^ typeFilter ifNil: [typeFilter := 1].! !

!UiWidgetListModel methodsFor: 'as yet unclassified' stamp: 'mt 7/1/2010 17:37:59.878'!
typeFilter: aNumber
	"1 ... widgets only
	2 ... all morphs"
	
	aNumber <= 0 ifTrue: [^ self filter: 1].
	typeFilter := aNumber.
	self changed: #widgetList.! !

!UiWidgetListModel methodsFor: 'as yet unclassified' stamp: 'mt 7/1/2010 17:48:05.422'!
widgetList

	^ Smalltalk allClasses
		select: [:c | (c inheritsFrom: Morph) and: [
			self typeFilter = 1
				ifTrue: [c isWidgetClass]
				ifFalse: [true]]
			and: [self nameFilter
				ifEmpty: [true]
				ifNotEmpty: [c asString asLowercase includesSubString: self nameFilter asString asLowercase]]]
		thenCollect: [:c | 
			c asString].
			"(c class methodDict includesKey: #widgetClassName)
				ifTrue: [c widgetClassName]
				ifFalse: [c asString]]"! !

!UiAbstractItemView methodsFor: 'testing' stamp: 'mt 10/14/2010 13:04:29.063'!
hasHorizontalHeader

	^ hHeaderScroller owner notNil! !

!UiAbstractItemView methodsFor: 'testing' stamp: 'mt 10/14/2010 13:03:13.199'!
hasVerticalHeader

	^ vHeaderScroller owner notNil! !

!UiContainer methodsFor: 'dropping/grabbing' stamp: 'mt 6/30/2010 09:20:13.411'!
acceptDroppingMorph: aMorph event: evt

	(aMorph isKindOf: TransferMorph)
		ifTrue: [ | newMorph |
			newMorph := (Smalltalk at: aMorph passenger contents asSymbol) perform: #new.
			newMorph position: evt position.
			self addMorphBack: newMorph.
			
			(newMorph isKindOf: UiContainer)
				ifTrue: [newMorph editMode: self editMode].
			
		^ self].

	^ super acceptDroppingMorph: aMorph event: evt.! !
